diff --git a/sim/mcore/ChangeLog b/sim/mcore/ChangeLog
index acb0e21..43aadab 100644
--- a/sim/mcore/ChangeLog
+++ b/sim/mcore/ChangeLog
@@ -1,3 +1,9 @@
+2015-02-20  Mike Frysinger  <vapier@gentoo.org>
+
+	* interp.c: Delete sysdep.h and netinet/in.h includes.
+	Include stdlib.h and string.h.
+	* sysdep.h: Delete.
+
 2015-02-19  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_kill): Delete unused func.
diff --git a/sim/mcore/interp.c b/sim/mcore/interp.c
index e2cafbc..1b8d2a3 100644
--- a/sim/mcore/interp.c
+++ b/sim/mcore/interp.c
@@ -19,10 +19,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include "config.h"
 #include <signal.h>
-#include "sysdep.h"
+#include <stdlib.h>
+#include <string.h>
 #include <sys/times.h>
 #include <sys/param.h>
-#include <netinet/in.h>	/* for byte ordering macros */
 #include <unistd.h>
 #include "bfd.h"
 #include "gdb/callback.h"
diff --git a/sim/mcore/sysdep.h b/sim/mcore/sysdep.h
deleted file mode 100644
index 9f690a1..0000000
--- a/sim/mcore/sysdep.h
+++ /dev/null
@@ -1,94 +0,0 @@
-/* System includes and definitions used by the Motorola MCore simulator.
-   Copyright (C) 1999-2015 Free Software Foundation, Inc.
-   Contributed by Cygnus Solutions.
-
-This file is part of GDB, the GNU debugger.
-
-This program is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 3 of the License, or
-(at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
-
-#ifndef __SYSDEP_H
-#define __SYSDEP_H
-
-#ifndef	hosts_std_host_H
-#include <fcntl.h>
-#include <errno.h>
-#include <stdio.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <ctype.h>
-#include <string.h>
-#include <sys/file.h>
-#include "ansidecl.h"
-
-#ifndef	O_ACCMODE
-#define O_ACCMODE (O_RDONLY | O_WRONLY | O_RDWR)
-#endif
-#ifndef	SEEK_SET
-#define SEEK_SET 0
-#endif
-#ifndef	SEEK_CUR
-#define SEEK_CUR 1
-#endif
-#ifdef STDC_HEADERS
-#include <stdlib.h>
-/*#include <string.h>*/
-#else
-extern char * mktemp ();
-#ifndef memset
-extern PTR    memset ();
-#endif
-
-#ifndef	DONTDECLARE_MALLOC
-extern PTR   malloc ();
-extern PTR   realloc ();
-#endif
-
-#ifndef	__GNUC__
-extern PTR   memcpy ();
-#else
-/* char * memcpy (); */
-#endif
-
-#ifdef __STDC__
-extern void free ();
-#else
-extern int free();
-#endif
-
-#ifndef strchr
-extern char * strchr();
-#endif
-extern char * getenv();
-extern PTR    memchr();
-extern char * strrchr();
-
-extern char * strrchr();
-extern char * ctime();
-extern long   atol();
-extern char * getenv();
-#endif /* STDC_HEADERS */
-
-#ifndef	BYTES_IN_PRINTF_INT
-#define BYTES_IN_PRINTF_INT 4
-#endif
-
-#include "fopen-same.h"
-#define hosts_std_host_H
-#endif
-
-#ifdef	STDC_HEADERS
-#include <stddef.h>
-#endif /* STDC_HEADERS */
-
-#endif /* __SYSDEP_H */
diff --git a/sim/microblaze/ChangeLog b/sim/microblaze/ChangeLog
index a023f92..0a068ff 100644
--- a/sim/microblaze/ChangeLog
+++ b/sim/microblaze/ChangeLog
@@ -1,3 +1,9 @@
+2015-02-20  Mike Frysinger  <vapier@gentoo.org>
+
+	* interp.c: Delete sysdep.h and netinet/in.h includes.
+	Include stdlib.h and string.h and unistd.h.
+	* sysdep.h: Delete.
+
 2015-02-19  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_kill): Delete unused func.
diff --git a/sim/microblaze/interp.c b/sim/microblaze/interp.c
index b9349bc..64850ef 100644
--- a/sim/microblaze/interp.c
+++ b/sim/microblaze/interp.c
@@ -18,10 +18,11 @@
 
 #include "config.h"
 #include <signal.h>
-#include "sysdep.h"
+#include <stdlib.h>
+#include <string.h>
 #include <sys/times.h>
 #include <sys/param.h>
-#include <netinet/in.h>	/* for byte ordering macros */
+#include <unistd.h>
 #include "bfd.h"
 #include "gdb/callback.h"
 #include "libiberty.h"
diff --git a/sim/microblaze/sysdep.h b/sim/microblaze/sysdep.h
deleted file mode 100644
index ebcd1f2..0000000
--- a/sim/microblaze/sysdep.h
+++ /dev/null
@@ -1,94 +0,0 @@
-/* System includes and definitions used by the Xilinx MicroBlaze simulator.
-   Copyright (C) 1999-2015 Free Software Foundation, Inc.
-   Contributed by Cygnus Solutions.
-
-This file is part of GDB, the GNU debugger.
-
-This program is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 3, or (at your option)
-any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License along
-with this program; if not, see <http://www.gnu.org/licenses/>.  */
-
-#ifndef __SYSDEP_H
-#define __SYSDEP_H
-
-#ifndef	hosts_std_host_H
-#include <fcntl.h>
-#include <errno.h>
-#include <stdio.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <ctype.h>
-#include <string.h>
-#include <sys/file.h>
-#include "ansidecl.h"
-
-#ifndef	O_ACCMODE
-#define O_ACCMODE (O_RDONLY | O_WRONLY | O_RDWR)
-#endif
-#ifndef	SEEK_SET
-#define SEEK_SET 0
-#endif
-#ifndef	SEEK_CUR
-#define SEEK_CUR 1
-#endif
-#ifdef STDC_HEADERS
-#include <stdlib.h>
-/*#include <string.h>*/
-#else
-extern char *mktemp ();
-#ifndef memset
-extern PTR    memset ();
-#endif
-
-#ifndef	DONTDECLARE_MALLOC
-extern PTR   malloc ();
-extern PTR   realloc ();
-#endif
-
-#ifndef	__GNUC__
-extern PTR   memcpy ();
-#else
-/* char *memcpy (); */
-#endif
-
-#ifdef __STDC__
-extern void free ();
-#else
-extern int free();
-#endif
-
-#ifndef strchr
-extern char *strchr();
-#endif
-extern char *getenv();
-extern PTR    memchr();
-extern char *strrchr();
-
-extern char *strrchr();
-extern char *ctime();
-extern long   atol();
-extern char *getenv();
-#endif /* STDC_HEADERS */
-
-#ifndef	BYTES_IN_PRINTF_INT
-#define BYTES_IN_PRINTF_INT 4
-#endif
-
-#include "fopen-same.h"
-#define hosts_std_host_H
-#endif
-
-#ifdef	STDC_HEADERS
-#include <stddef.h>
-#endif /* STDC_HEADERS */
-
-#endif /* __SYSDEP_H */
diff --git a/sim/moxie/ChangeLog b/sim/moxie/ChangeLog
index 3b458ed..6e6f736 100644
--- a/sim/moxie/ChangeLog
+++ b/sim/moxie/ChangeLog
@@ -1,3 +1,9 @@
+2015-02-20  Mike Frysinger  <vapier@gentoo.org>
+
+	* interp.c: Delete sysdep.h and netinet/in.h includes.
+	Include string.h and unistd.h.
+	* sysdep.h: Delete.
+
 2015-02-19  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_kill): Delete unused func.
diff --git a/sim/moxie/interp.c b/sim/moxie/interp.c
index 6e4a747..1126552 100644
--- a/sim/moxie/interp.c
+++ b/sim/moxie/interp.c
@@ -21,10 +21,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 #include <fcntl.h>
 #include <signal.h>
 #include <stdlib.h>
-#include "sysdep.h"
+#include <string.h>
 #include <sys/times.h>
 #include <sys/param.h>
-#include <netinet/in.h>	/* for byte ordering macros */
+#include <unistd.h>
 #include "bfd.h"
 #include "gdb/callback.h"
 #include "libiberty.h"
diff --git a/sim/moxie/sysdep.h b/sim/moxie/sysdep.h
deleted file mode 100644
index ba9778e..0000000
--- a/sim/moxie/sysdep.h
+++ /dev/null
@@ -1,94 +0,0 @@
-/* System includes and definitions used by the moxie simulator.
-   Copyright (C) 2008-2015 Free Software Foundation, Inc.
-   Contributed by Anthony Green
-
-This file is part of GDB, the GNU debugger.
-
-This program is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 3 of the License, or
-(at your option) any later version.
-
-This program is distributed in the hope that it will be useful,
-but WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-GNU General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
-
-#ifndef __SYSDEP_H
-#define __SYSDEP_H
-
-#ifndef	hosts_std_host_H
-#include <fcntl.h>
-#include <errno.h>
-#include <stdio.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <ctype.h>
-#include <string.h>
-#include <sys/file.h>
-#include "ansidecl.h"
-
-#ifndef	O_ACCMODE
-#define O_ACCMODE (O_RDONLY | O_WRONLY | O_RDWR)
-#endif
-#ifndef	SEEK_SET
-#define SEEK_SET 0
-#endif
-#ifndef	SEEK_CUR
-#define SEEK_CUR 1
-#endif
-#ifdef STDC_HEADERS
-#include <stdlib.h>
-/*#include <string.h>*/
-#else
-extern char * mktemp ();
-#ifndef memset
-extern PTR    memset ();
-#endif
-
-#ifndef	DONTDECLARE_MALLOC
-extern PTR   malloc ();
-extern PTR   realloc ();
-#endif
-
-#ifndef	__GNUC__
-extern PTR   memcpy ();
-#else
-/* char * memcpy (); */
-#endif
-
-#ifdef __STDC__
-extern void free ();
-#else
-extern int free();
-#endif
-
-#ifndef strchr
-extern char * strchr();
-#endif
-extern char * getenv();
-extern PTR    memchr();
-extern char * strrchr();
-
-extern char * strrchr();
-extern char * ctime();
-extern long   atol();
-extern char * getenv();
-#endif /* STDC_HEADERS */
-
-#ifndef	BYTES_IN_PRINTF_INT
-#define BYTES_IN_PRINTF_INT 4
-#endif
-
-#include "fopen-same.h"
-#define hosts_std_host_H
-#endif
-
-#ifdef	STDC_HEADERS
-#include <stddef.h>
-#endif /* STDC_HEADERS */
-
-#endif /* __SYSDEP_H */