diff --git a/sim/.gitignore b/sim/.gitignore
index 9440b89..0dce65b 100644
--- a/sim/.gitignore
+++ b/sim/.gitignore
@@ -2,7 +2,6 @@
 /*/run
 /*/hw-config.h
 /*/targ-*
-/*/tconfig.h
 /*/version.c
 
 /common/cconfig.h
diff --git a/sim/ChangeLog b/sim/ChangeLog
index 35d0920..37ee409 100644
--- a/sim/ChangeLog
+++ b/sim/ChangeLog
@@ -1,3 +1,8 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* .gitignore: Delete tconfig.h.
+	* README-HACKING: Change tconfig.in to tconfig.h.
+
 2014-03-12  Nick Clifton  <nickc@redhat.com>
 
 	* MAINTAINERS: Add myself as the maintainer for the MSP430.
diff --git a/sim/README-HACKING b/sim/README-HACKING
index 33b6ecb..0a6bbe2 100644
--- a/sim/README-HACKING
+++ b/sim/README-HACKING
@@ -7,7 +7,7 @@ Contents
 - Common Makefile Support
 - TAGS support
 - Generating "configure" files
-- tconfig.in
+- tconfig.h
 - C Language Assumptions
 - "dump" commands under gdb
 
@@ -159,12 +159,12 @@ To add the entries to an alternative ChangeLog file, use:
 	$  make ChangeLog=MyChangeLog ....
 
 
-tconfig.in
+tconfig.h
 ==========
 
-File tconfig.in defines one or more target configuration macros
+File tconfig.h defines one or more target configuration macros
 (e.g. a tm.h file).  There are very few that need defining.
-For a list of all of them, see common/tconfig.in.
+For a list of all of them, see common/tconfig.h.
 It contains them all, commented out.
 The intent is that a new port can just copy this file and
 define the ones it needs.
diff --git a/sim/arm/ChangeLog b/sim/arm/ChangeLog
index bd4ddf2..94bd72f 100644
--- a/sim/arm/ChangeLog
+++ b/sim/arm/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CFLAGS): Add
diff --git a/sim/arm/config.in b/sim/arm/config.in
index 5fed8c1..5ded703 100644
diff --git a/sim/arm/configure b/sim/arm/configure
index 9ee8a77..4e0221e 100755
diff --git a/sim/arm/tconfig.in b/sim/arm/tconfig.h
similarity index 100%
rename from sim/arm/tconfig.in
rename to sim/arm/tconfig.h
diff --git a/sim/avr/ChangeLog b/sim/avr/ChangeLog
index 9105e38..6f1e042 100644
--- a/sim/avr/ChangeLog
+++ b/sim/avr/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CFLAGS): Set to
diff --git a/sim/avr/aclocal.m4 b/sim/avr/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/avr/config.in b/sim/avr/config.in
index 5fed8c1..5ded703 100644
diff --git a/sim/avr/configure b/sim/avr/configure
index 3f271cc..fa26277 100755
diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index 4e2077d..13617de 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in: Delete includes.
diff --git a/sim/bfin/aclocal.m4 b/sim/bfin/aclocal.m4
index e93cce7..a1b18dc 100644
diff --git a/sim/bfin/config.in b/sim/bfin/config.in
index 4e2f6d4..20a094e 100644
diff --git a/sim/bfin/configure b/sim/bfin/configure
index 6654216..e77e98a 100755
diff --git a/sim/bfin/tconfig.in b/sim/bfin/tconfig.h
similarity index 100%
rename from sim/bfin/tconfig.in
rename to sim/bfin/tconfig.h
diff --git a/sim/common/ChangeLog b/sim/common/ChangeLog
index 08d3b93..b756733 100644
--- a/sim/common/ChangeLog
+++ b/sim/common/ChangeLog
@@ -1,3 +1,12 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* acinclude.m4 (SIM_AC_COMMON): Call AH_BOTTOM.  Delete logic for
+	symlinking tconfig.h to tconfig.in.
+	* config.in, configure: Regenerate.
+	* nrun.c, run.c, sim-basics.h: Delete tconfig.h include.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* dv-socker.h (dv_sockser_install): Declare.
diff --git a/sim/common/acinclude.m4 b/sim/common/acinclude.m4
index f96ec35..2e1d31f 100644
--- a/sim/common/acinclude.m4
+++ b/sim/common/acinclude.m4
@@ -53,6 +53,9 @@ AR=${AR-ar}
 AC_SUBST(AR)
 AC_PROG_RANLIB
 
+dnl Pull in the target configuration file directly.
+AH_BOTTOM([#include "tconfig.h"])
+
 # Some of the common include files depend on bfd.h, and bfd.h checks
 # that config.h is included first by testing that the PACKAGE macro
 # is defined.
@@ -247,16 +250,6 @@ dnl These are available to append to as desired.
 sim_link_files=
 sim_link_links=
 
-dnl Create tconfig.h either from simulator's tconfig.in or default one
-dnl in common.
-sim_link_links=tconfig.h
-if test -f ${srcdir}/tconfig.in
-then
-  sim_link_files=tconfig.in
-else
-  sim_link_files=../common/tconfig.in
-fi
-
 # targ-vals.def points to the libc macro description file.
 case "${target}" in
 *-*-*) TARG_VALS_DEF=../common/nltvals.def ;;
diff --git a/sim/common/config.in b/sim/common/config.in
index 5b8ebd8..e0ca8ae 100644
diff --git a/sim/common/configure b/sim/common/configure
index add4c0f..db5f661 100755
diff --git a/sim/common/nrun.c b/sim/common/nrun.c
index eccb0cb..e3f3c42 100644
--- a/sim/common/nrun.c
+++ b/sim/common/nrun.c
@@ -17,7 +17,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 /* Need to be before general includes, to pick up e.g. _GNU_SOURCE.  */
 #ifdef HAVE_CONFIG_H
 #include "cconfig.h"
-#include "tconfig.h"
 #endif
 
 #include <signal.h>
diff --git a/sim/common/run.c b/sim/common/run.c
index e474661..3be10ab 100644
--- a/sim/common/run.c
+++ b/sim/common/run.c
@@ -19,7 +19,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #ifdef HAVE_CONFIG_H
 #include "cconfig.h"
-#include "tconfig.h"
 #endif
 
 #include <signal.h>
diff --git a/sim/common/sim-basics.h b/sim/common/sim-basics.h
index 2a410bb..2730569 100644
--- a/sim/common/sim-basics.h
+++ b/sim/common/sim-basics.h
@@ -126,11 +126,6 @@ typedef enum {
 
 /* Basic definitions - ordered so that nothing calls what comes after it.  */
 
-/* FIXME: conditionalizing tconfig.h on HAVE_CONFIG_H seems wrong.  */
-#ifdef HAVE_CONFIG_H
-#include "tconfig.h"
-#endif
-
 #include "ansidecl.h"
 #include "gdb/callback.h"
 #include "gdb/remote-sim.h"
diff --git a/sim/common/tconfig.in b/sim/common/tconfig.h
similarity index 100%
rename from sim/common/tconfig.in
rename to sim/common/tconfig.h
diff --git a/sim/cr16/ChangeLog b/sim/cr16/ChangeLog
index 3a81178..9669379 100644
--- a/sim/cr16/ChangeLog
+++ b/sim/cr16/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CFLAGS): Add
diff --git a/sim/cr16/config.in b/sim/cr16/config.in
index 5fed8c1..5ded703 100644
diff --git a/sim/cr16/configure b/sim/cr16/configure
index b154ae0..c7e82ec 100755
diff --git a/sim/cris/ChangeLog b/sim/cris/ChangeLog
index 9432e32..d2f912d 100644
--- a/sim/cris/ChangeLog
+++ b/sim/cris/ChangeLog
@@ -1,3 +1,10 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+	* rvdummy.c: Delete tconfig.h include.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in: Delete most includes.
diff --git a/sim/cris/aclocal.m4 b/sim/cris/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/cris/config.in b/sim/cris/config.in
index 05c2fde..c333731 100644
diff --git a/sim/cris/configure b/sim/cris/configure
index 610da55..7c9094e 100755
diff --git a/sim/cris/rvdummy.c b/sim/cris/rvdummy.c
index 6e2e092..f788686 100644
--- a/sim/cris/rvdummy.c
+++ b/sim/cris/rvdummy.c
@@ -31,7 +31,6 @@ main (int argc, char *argv[])
 
 #ifdef HAVE_CONFIG_H
 #include "cconfig.h"
-#include "tconfig.h"
 #endif
 
 #include "getopt.h"
diff --git a/sim/cris/tconfig.in b/sim/cris/tconfig.h
similarity index 100%
rename from sim/cris/tconfig.in
rename to sim/cris/tconfig.h
diff --git a/sim/d10v/ChangeLog b/sim/d10v/ChangeLog
index 728d5af..8bb2666 100644
--- a/sim/d10v/ChangeLog
+++ b/sim/d10v/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CFLAGS): Add
diff --git a/sim/d10v/config.in b/sim/d10v/config.in
index 5fed8c1..5ded703 100644
diff --git a/sim/d10v/configure b/sim/d10v/configure
index b154ae0..c7e82ec 100755
diff --git a/sim/erc32/ChangeLog b/sim/erc32/ChangeLog
index 41c465e..8211b4a 100644
--- a/sim/erc32/ChangeLog
+++ b/sim/erc32/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-16  Jiri Gaisler  <jiri@gaisler.se>
 
 	* Makefile.in (end, end.h): Remove target rules.
diff --git a/sim/erc32/config.in b/sim/erc32/config.in
index b367e14..6003e58 100644
diff --git a/sim/erc32/configure b/sim/erc32/configure
index 4899feb..6b1f4bb 100755
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index d178047..5968f7e 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in [HAVE_DV_SOCKSER]: Delete.
diff --git a/sim/frv/aclocal.m4 b/sim/frv/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/frv/config.in b/sim/frv/config.in
index 23fafed..bf39e2d 100644
diff --git a/sim/frv/configure b/sim/frv/configure
index 78b5450..d312971 100755
diff --git a/sim/frv/tconfig.in b/sim/frv/tconfig.h
similarity index 100%
rename from sim/frv/tconfig.in
rename to sim/frv/tconfig.h
diff --git a/sim/h8300/ChangeLog b/sim/h8300/ChangeLog
index ec21cbf..0ef2344 100644
--- a/sim/h8300/ChangeLog
+++ b/sim/h8300/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_RUN_OBJS): Delete.
diff --git a/sim/h8300/config.in b/sim/h8300/config.in
index e58e199..27216dc 100644
diff --git a/sim/h8300/configure b/sim/h8300/configure
index 39185a1..37b2d87 100755
diff --git a/sim/h8300/tconfig.in b/sim/h8300/tconfig.h
similarity index 100%
rename from sim/h8300/tconfig.in
rename to sim/h8300/tconfig.h
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index b682fac..884c21f 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in [HAVE_DV_SOCKSER]: Delete.
diff --git a/sim/iq2000/aclocal.m4 b/sim/iq2000/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/iq2000/config.in b/sim/iq2000/config.in
index 23fafed..bf39e2d 100644
diff --git a/sim/iq2000/configure b/sim/iq2000/configure
index 626fbdd..353ace0 100755
diff --git a/sim/iq2000/tconfig.in b/sim/iq2000/tconfig.h
similarity index 100%
rename from sim/iq2000/tconfig.in
rename to sim/iq2000/tconfig.h
diff --git a/sim/lm32/ChangeLog b/sim/lm32/ChangeLog
index 954cd83..a02609e 100644
--- a/sim/lm32/ChangeLog
+++ b/sim/lm32/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_OBJS): Add @SIM_DV_SOCKSER_O@.
diff --git a/sim/lm32/aclocal.m4 b/sim/lm32/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/lm32/config.in b/sim/lm32/config.in
index 23fafed..bf39e2d 100644
diff --git a/sim/lm32/configure b/sim/lm32/configure
index b48cb20..22ed7d5 100755
diff --git a/sim/lm32/tconfig.in b/sim/lm32/tconfig.h
similarity index 100%
rename from sim/lm32/tconfig.in
rename to sim/lm32/tconfig.h
diff --git a/sim/m32c/ChangeLog b/sim/m32c/ChangeLog
index 9259ad7..9e2adcc 100644
--- a/sim/m32c/ChangeLog
+++ b/sim/m32c/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+
 2014-08-19  Alan Modra  <amodra@gmail.com>
 
 	* configure: Regenerate.
diff --git a/sim/m32c/aclocal.m4 b/sim/m32c/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/m32c/config.in b/sim/m32c/config.in
index 88ae415..02a82ae 100644
diff --git a/sim/m32c/configure b/sim/m32c/configure
index dcc8c2d..ca46b2b 100755
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index ee4d689..bc379a0 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in [HAVE_DV_SOCKSER]: Delete.
diff --git a/sim/m32r/aclocal.m4 b/sim/m32r/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/m32r/config.in b/sim/m32r/config.in
index 23fafed..bf39e2d 100644
diff --git a/sim/m32r/configure b/sim/m32r/configure
index dea90b7..0065621 100755
diff --git a/sim/m32r/tconfig.in b/sim/m32r/tconfig.h
similarity index 100%
rename from sim/m32r/tconfig.in
rename to sim/m32r/tconfig.h
diff --git a/sim/m68hc11/ChangeLog b/sim/m68hc11/ChangeLog
index 6e10a38..712dcf9 100644
--- a/sim/m68hc11/ChangeLog
+++ b/sim/m68hc11/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_RUN_OBJS): Delete.
diff --git a/sim/m68hc11/config.in b/sim/m68hc11/config.in
index 23fafed..bf39e2d 100644
diff --git a/sim/m68hc11/configure b/sim/m68hc11/configure
index 47a7e64..5b85244 100755
diff --git a/sim/mcore/ChangeLog b/sim/mcore/ChangeLog
index 5d9fb6b..c3256f4 100644
--- a/sim/mcore/ChangeLog
+++ b/sim/mcore/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CLEAN): Delete.
diff --git a/sim/mcore/config.in b/sim/mcore/config.in
index 5fed8c1..5ded703 100644
diff --git a/sim/mcore/configure b/sim/mcore/configure
index 3785c22..fa26277 100755
diff --git a/sim/microblaze/ChangeLog b/sim/microblaze/ChangeLog
index ceb1dd5..2c41a76 100644
--- a/sim/microblaze/ChangeLog
+++ b/sim/microblaze/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CFLAGS): Set to
diff --git a/sim/microblaze/config.in b/sim/microblaze/config.in
index 5fed8c1..5ded703 100644
diff --git a/sim/microblaze/configure b/sim/microblaze/configure
index 3785c22..fa26277 100755
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index 2be47e0..f8c3494 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in: Delete includes.
diff --git a/sim/mips/config.in b/sim/mips/config.in
index 83a39b5..f5a103d 100644
diff --git a/sim/mips/configure b/sim/mips/configure
index b2e164d..39c20b9 100755
diff --git a/sim/mips/tconfig.in b/sim/mips/tconfig.h
similarity index 100%
rename from sim/mips/tconfig.in
rename to sim/mips/tconfig.h
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index aa9f5f1..bdf8b2c 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in: Delete file.
diff --git a/sim/mn10300/config.in b/sim/mn10300/config.in
index 95f0aab..f6a87f1 100644
diff --git a/sim/mn10300/configure b/sim/mn10300/configure
index 435db0d..9cba769 100755
diff --git a/sim/moxie/ChangeLog b/sim/moxie/ChangeLog
index bcdc1fa..f509fc0 100644
--- a/sim/moxie/ChangeLog
+++ b/sim/moxie/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CLEAN): Delete.
diff --git a/sim/moxie/config.in b/sim/moxie/config.in
index b367e14..6003e58 100644
diff --git a/sim/moxie/configure b/sim/moxie/configure
index 1542765..ccfdb77 100755
diff --git a/sim/msp430/ChangeLog b/sim/msp430/ChangeLog
index d351d64..5bcab32 100644
--- a/sim/msp430/ChangeLog
+++ b/sim/msp430/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* aclocal.m4, configure: Regenerate.
diff --git a/sim/msp430/config.in b/sim/msp430/config.in
index 03f7d91..df5c0d3 100644
diff --git a/sim/msp430/configure b/sim/msp430/configure
index 2ed3724..af8b6bf 100755
diff --git a/sim/rl78/ChangeLog b/sim/rl78/ChangeLog
index cd2914e..3c92412 100644
--- a/sim/rl78/ChangeLog
+++ b/sim/rl78/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+
 2014-08-19  Alan Modra  <amodra@gmail.com>
 
 	* configure: Regenerate.
diff --git a/sim/rl78/aclocal.m4 b/sim/rl78/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/rl78/config.in b/sim/rl78/config.in
index 03f7d91..df5c0d3 100644
diff --git a/sim/rl78/configure b/sim/rl78/configure
index 626b1eb..752cbcb 100755
diff --git a/sim/rx/ChangeLog b/sim/rx/ChangeLog
index 8d4c4ec..90a36e0 100644
--- a/sim/rx/ChangeLog
+++ b/sim/rx/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+
 2015-12-15  Joel Brobecker  <brobecker@adacore.com>
 
 	* gdb-if.c (open): Rename to...
diff --git a/sim/rx/aclocal.m4 b/sim/rx/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/rx/config.in b/sim/rx/config.in
index c510fbe..f7ccc45 100644
diff --git a/sim/rx/configure b/sim/rx/configure
index 4023064..7f5e70a 100755
diff --git a/sim/sh/ChangeLog b/sim/sh/ChangeLog
index 8603da5..674a676 100644
--- a/sim/sh/ChangeLog
+++ b/sim/sh/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_EXTRA_CFLAGS): Set to
diff --git a/sim/sh/config.in b/sim/sh/config.in
index 5fed8c1..5ded703 100644
diff --git a/sim/sh/configure b/sim/sh/configure
index 3785c22..fa26277 100755
diff --git a/sim/sh/tconfig.in b/sim/sh/tconfig.h
similarity index 100%
rename from sim/sh/tconfig.in
rename to sim/sh/tconfig.h
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index 20da758..ca0dee6 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -1,3 +1,9 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* aclocal.m4, config.in, configure: Regenerate.
+	* tconfig.in: Rename file ...
+	* tconfig.h: ... here.
+
 2015-03-15  Mike Frysinger  <vapier@gentoo.org>
 
 	* tconfig.in [HAVE_DV_SOCKSER]: Delete.
diff --git a/sim/sh64/aclocal.m4 b/sim/sh64/aclocal.m4
index a24bbeb..517bc73 100644
diff --git a/sim/sh64/config.in b/sim/sh64/config.in
index 23fafed..bf39e2d 100644
diff --git a/sim/sh64/configure b/sim/sh64/configure
index 18f98fb..c298280 100755
diff --git a/sim/sh64/tconfig.in b/sim/sh64/tconfig.h
similarity index 100%
rename from sim/sh64/tconfig.in
rename to sim/sh64/tconfig.h
diff --git a/sim/v850/ChangeLog b/sim/v850/ChangeLog
index 8578b8a..853f9f7 100644
--- a/sim/v850/ChangeLog
+++ b/sim/v850/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-16  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2015-03-14  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (SIM_RUN_OBJS): Delete.